



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>LA 3295 (计数 容斥原理) Counting Triangles</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">LA 3295 (计数 容斥原理) Counting Triangles</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 15:46:22 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>如果用容斥原理递推的办法，这道题确实和LA 3720 Highway很像。</p>
<p>看到大神们写的博客，什么乱搞啊，随便统计一下，这真的让小白很为难，于是我决定用比较严格的语言来写这篇题解。</p>
<p>整体思路很简单：m*n的方格，其格点是(m+1)*(n+1)的点阵，选三个点有C((m+1)*(n+1), 3)中情况，其中能构成三角形的不容易计算，所以计算它的反面：三个点不能构成三角形，即三点共线的情况。</p>
<p>三点共线的情况也可以再分为三类：</p>
<p>①三点在一条水平线上，共有m*C(n+1, 3)种情况。</p>
<p>②三点在一条竖直线上，共有n*C(m+1, 3)种情况。</p>
<p>③然后就是三点在斜线下的情况，由于是对称的，不妨先统计\左上到右下方向的直线，最后乘2即可。</p>
<p>首先是gcd(i, j) - 1的含义：这是起点为(0, 0)终点为(i, j)的所有三点共线的情况。</p>
<p>令dp(i, j)表示i*j大小的方格中 有一个点在右下角 的三点共线的情况，根据容斥原理有如下递推关系：</p>
<p>dp(i, j) = dp(i-1, j) + dp(i, j-1) - dp(i-1, j-1) +&nbsp;gcd(i, j) - 1</p>
<p>令sum(i, j)表示i*j大小的方格中\方向的三点共线情况，也可以类似地递推：</p>
<p>sum(i, j) = sum(i-1, j) + sum(i, j-1) - sum(i-1, j-1) + dp(i, j)</p>
<p>最终答案就是：C((m+1)*(n+1), 3) -&nbsp;m*C(n+1, 3) -&nbsp;n*C(m+1, 3) - sum(i, j) * 2</p>
<div>
<div>
<pre class="prettyprint linenums"> #include &lt;cstdio&gt;<br />
 typedef long long LL;

 const int maxn = ;<br />
 LL dp[maxn + ][maxn + ], sum[maxn + ][maxn + ];

 int gcd(int a, int b) { return b ==  ? a : gcd(b, a%b); }

 LL C(LL n) { return (LL)n * (n-) /  * (n-) / ; }

 int main()<br />
 {<br />
     for(int i = ; i &lt;= maxn; i++)<br />
         for(int j = ; j &lt;= maxn; j++)<br />
             dp[i][j] = dp[i-][j] + dp[i][j-] - dp[i-][j-] + gcd(i, j) - ;<br />
     for(int i = ; i &lt;= maxn; i++)<br />
         for(int j = ; j &lt;= maxn; j++)<br />
             sum[i][j] = dp[i][j] + sum[i][j-] + sum[i-][j] - sum[i-][j-];

     int n, m, kase = ;<br />
     while(scanf("%d%d", &amp;n, &amp;m) ==  &amp;&amp; n)<br />
     {<br />
         n++; m++;<br />
         printf("Case %d: %lld\n", ++kase, C(n*m) - C(n)*m - C(m)*n - sum[n-][m-] * );<br />
     }

     return ;<br />
 }</pre>
</div>
<p>代码君</p></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxjkzz9.html">三、jQuery--jQuery基础--jQuery基础课程--第8章 jQuery 实现Ajax应用</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93z5lrq.html">php分享三十三：常量</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xoeyg9.html">VC&plus;&plus;检测当前网络状态</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmj1z69.html">HDU 3333 - Turing Tree &lpar;树状数组&plus;离线处理&plus;哈希&plus;贪心&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvr0rjq.html">SQL SERVER开窗函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdn1jy8.html">Java中的break与continue区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvmypoq.html">Linq101-Projection</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjolm49.html">SQL利用临时表实现动态列、动态添加列</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1wdm69.html">linux自带有usb驱动，为什么还需要libusb呢</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp10559.html">Buenos Aires和Rio de Janeiro怎么发音？</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj47xlq.html">Ambari中添加新服务</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdreoy9.html">IIS日志分析工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gelm778.html">Visual Studio 2017 设置透明背景图</a>
		</li>
						<li><a href="https://www.batexi.com/a/9506kez8.html">SQL join 连接时 条件加在 on后面和 where 的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1gxe1q.html">用JDBC连接 数据库 进行简单的增删改查</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvnrek8.html">Go&plus;Python双剑合璧</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gz67zq.html">shell脚本四-三剑客</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwr1748.html">WORD 的 Open 和Workbook 的 LoadFromFile 函数返回null的一种解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zk420n8.html">元素的定位id和name</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ev1ng9.html">超全面的JavaWeb笔记day22&amp;lt&semi;文件上传&amp;gt&semi;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8okgd3x9.html">android  有时候stroke不起作用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnwd6rq.html">Text selection in div&lpar;contenteditable&rpar; when double click</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnwl4rq.html">linux 下安装 nginx</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pj3x2d9.html">后缀树（Suffix Tree）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w23mxq.html">01-03-03【Nhibernate &lpar;版本3&period;3&period;1&period;4000&rpar; 出入江湖】cascade的测试</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rd17v48.html">Sqlitekit 封装管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1ygog8.html">override equals in Java</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2w26doq.html">SDUT1574组合数的计算（组合数）</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mgj11q.html">【转载】Ssh整合开发介绍和简单的登入案例实现</a>
			</li>
						<li><a href="https://www.batexi.com/a/95xwywv8.html">如何正确学习JavaScript</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
